Subject: Re: bug#69807: questioning automatic -i in multicolumn pr
From: Pádraig Brady <[email-masked]>
To: Douglas McIlroy <[email-masked]>, [email-masked]
Date: Thu, 21 Mar 2024 15:33:19 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On 14/03/2024 20:31, Douglas McIlroy wrote:
> Multicolumn options in pr imply option -i (tabification). The introduction
> of tabs with physical rather than logical meaning makes output that is OK
> for viewing only if you have correct tab stops, and is complicated for
> further processing.  It caters for obsolete equipment--typewriters, on
> which tabbing was appreciably faster than spacing.
> 
> As a wish-list item I propose abolishing implicit tabification. A second
> choice (that doesn't buck Posix) is to provide an option to suppress
> implicit tabification. At a bare minimum, document a workaround for the
> inconvenient tabs, e.g. post-processing with pr -t -e.

Good call on the documentation.  I'll add this now:

commit 91e69cd2d02f015fc296e02388e0b18a293faa56 (HEAD -> master)
Author: Pádraig Brady <[email-masked]>
Date:   Thu Mar 21 15:26:48 2024 +0000

     doc: pr: give solution to expanding TABs in multicolumn output

     * doc/coreutils.texi (pr invocation): Explicitly state that
     multicolumn output will convert spaces to TABs, and show that
     this can be undone with the `pr -t -e` or `expand` commands.
     Suggested by Douglas McIlroy in https://bugs.gnu.org/69807

diff --git a/doc/coreutils.texi b/doc/coreutils.texi
index e36269588..37d729089 100644
--- a/doc/coreutils.texi
+++ b/doc/coreutils.texi
@@ -2636,9 +2636,11 @@ This option might well cause some lines to be truncated.>
  lines in the columns on each page are balanced.  The options @option{-e}
  and @option{-i} are on for multiple text-column output.  Together with
  @option{-J} option column alignment and line truncation is turned off.
+Since spaces are converted to TABs in multicolumn output, they can be converted
+back by further processing through @command{pr -t -e} or @command{expand}.

thanks,
Pádraig